###
### This file was automatically generated
###

from archinfo.arch import register_arch, Endness, Register

from .common import ArchPcode


class ArchPcode_sparc_BE_64_default(ArchPcode):
    name = 'sparc:BE:64:default'
    pcode_arch = 'sparc:BE:64:default'
    description = 'Sparc V9 64-bit'
    bits = 64
    ip_offset = 0x1000
    sp_offset = 0x70
    bp_offset = sp_offset
    instruction_endness = Endness.BE
    register_list = [
        Register('g0', 8, 0x0),
        Register('g1', 8, 0x8),
        Register('g2', 8, 0x10),
        Register('g3', 8, 0x18),
        Register('g4', 8, 0x20),
        Register('g5', 8, 0x28),
        Register('g6', 8, 0x30),
        Register('g7', 8, 0x38),
        Register('o0', 8, 0x40),
        Register('o1', 8, 0x48),
        Register('o2', 8, 0x50),
        Register('o3', 8, 0x58),
        Register('o4', 8, 0x60),
        Register('o5', 8, 0x68),
        Register('sp', 8, 0x70),
        Register('o7', 8, 0x78),
        Register('l0', 8, 0x80),
        Register('l1', 8, 0x88),
        Register('l2', 8, 0x90),
        Register('l3', 8, 0x98),
        Register('l4', 8, 0xa0),
        Register('l5', 8, 0xa8),
        Register('l6', 8, 0xb0),
        Register('l7', 8, 0xb8),
        Register('i0', 8, 0xc0),
        Register('i1', 8, 0xc8),
        Register('i2', 8, 0xd0),
        Register('i3', 8, 0xd8),
        Register('i4', 8, 0xe0),
        Register('i5', 8, 0xe8),
        Register('fp', 8, 0xf0),
        Register('i7', 8, 0xf8),
        Register('s_l0', 8, 0x500),
        Register('s_l1', 8, 0x508),
        Register('s_l2', 8, 0x510),
        Register('s_l3', 8, 0x518),
        Register('s_l4', 8, 0x520),
        Register('s_l5', 8, 0x528),
        Register('s_l6', 8, 0x530),
        Register('s_l7', 8, 0x538),
        Register('s_i0', 8, 0x540),
        Register('s_i1', 8, 0x548),
        Register('s_i2', 8, 0x550),
        Register('s_i3', 8, 0x558),
        Register('s_i4', 8, 0x560),
        Register('s_i5', 8, 0x568),
        Register('s_fp', 8, 0x570),
        Register('s_i7', 8, 0x578),
        Register('pc', 8, 0x1000, alias_names=('ip',)),
        Register('npc', 8, 0x1008),
        Register('asr', 8, 0x1010),
        Register('tick', 8, 0x1018),
        Register('y', 8, 0x1020),
        Register('ccr', 8, 0x1028),
        Register('fprs', 1, 0x4008),
        Register('pcr', 8, 0x1038),
        Register('pic', 8, 0x1040),
        Register('gsr', 8, 0x1048),
        Register('softint_set', 8, 0x1050),
        Register('softint_clr', 8, 0x1058),
        Register('softint', 8, 0x1060),
        Register('tick_cmpr', 8, 0x1068),
        Register('stick', 8, 0x1070),
        Register('stick_cmpr', 8, 0x1078),
        Register('asr7', 8, 0x1100),
        Register('asr8', 8, 0x1108),
        Register('asr9', 8, 0x1110),
        Register('asr10', 8, 0x1118),
        Register('asr11', 8, 0x1120),
        Register('asr12', 8, 0x1128),
        Register('asr13', 8, 0x1130),
        Register('asr14', 8, 0x1138),
        Register('asr15', 8, 0x1140),
        Register('asr16', 8, 0x1148),
        Register('asr17', 8, 0x1150),
        Register('asr18', 8, 0x1158),
        Register('asr19', 8, 0x1160),
        Register('asr20', 8, 0x1168),
        Register('asr21', 8, 0x1170),
        Register('asr22', 8, 0x1178),
        Register('asr23', 8, 0x1180),
        Register('asr24', 8, 0x1188),
        Register('asr25', 8, 0x1190),
        Register('asr26', 8, 0x1198),
        Register('asr27', 8, 0x11a0),
        Register('asr28', 8, 0x11a8),
        Register('asr29', 8, 0x11b0),
        Register('asr30', 8, 0x11b8),
        Register('asr31', 8, 0x11c0),
        Register('fq0', 16, 0x2000),
        Register('fd0', 8, 0x2000),
        Register('fs0', 4, 0x2000),
        Register('fs1', 4, 0x2004),
        Register('fd2', 8, 0x2008),
        Register('fs2', 4, 0x2008),
        Register('fs3', 4, 0x200c),
        Register('fq4', 16, 0x2010),
        Register('fd4', 8, 0x2010),
        Register('fs4', 4, 0x2010),
        Register('fs5', 4, 0x2014),
        Register('fd6', 8, 0x2018),
        Register('fs6', 4, 0x2018),
        Register('fs7', 4, 0x201c),
        Register('fq8', 16, 0x2020),
        Register('fd8', 8, 0x2020),
        Register('fs8', 4, 0x2020),
        Register('fs9', 4, 0x2024),
        Register('fd10', 8, 0x2028),
        Register('fs10', 4, 0x2028),
        Register('fs11', 4, 0x202c),
        Register('fq12', 16, 0x2030),
        Register('fd12', 8, 0x2030),
        Register('fs12', 4, 0x2030),
        Register('fs13', 4, 0x2034),
        Register('fd14', 8, 0x2038),
        Register('fs14', 4, 0x2038),
        Register('fs15', 4, 0x203c),
        Register('fq16', 16, 0x2040),
        Register('fd16', 8, 0x2040),
        Register('fs16', 4, 0x2040),
        Register('fs17', 4, 0x2044),
        Register('fd18', 8, 0x2048),
        Register('fs18', 4, 0x2048),
        Register('fs19', 4, 0x204c),
        Register('fq20', 16, 0x2050),
        Register('fd20', 8, 0x2050),
        Register('fs20', 4, 0x2050),
        Register('fs21', 4, 0x2054),
        Register('fd22', 8, 0x2058),
        Register('fs22', 4, 0x2058),
        Register('fs23', 4, 0x205c),
        Register('fq24', 16, 0x2060),
        Register('fd24', 8, 0x2060),
        Register('fs24', 4, 0x2060),
        Register('fs25', 4, 0x2064),
        Register('fd26', 8, 0x2068),
        Register('fs26', 4, 0x2068),
        Register('fs27', 4, 0x206c),
        Register('fq28', 16, 0x2070),
        Register('fd28', 8, 0x2070),
        Register('fs28', 4, 0x2070),
        Register('fs29', 4, 0x2074),
        Register('fd30', 8, 0x2078),
        Register('fs30', 4, 0x2078),
        Register('fs31', 4, 0x207c),
        Register('fq32', 16, 0x2080),
        Register('fd32', 8, 0x2080),
        Register('fd34', 8, 0x2088),
        Register('fq36', 16, 0x2090),
        Register('fd36', 8, 0x2090),
        Register('fd38', 8, 0x2098),
        Register('fq40', 16, 0x20a0),
        Register('fd40', 8, 0x20a0),
        Register('fd42', 8, 0x20a8),
        Register('fq44', 16, 0x20b0),
        Register('fd44', 8, 0x20b0),
        Register('fd46', 8, 0x20b8),
        Register('fq48', 16, 0x20c0),
        Register('fd48', 8, 0x20c0),
        Register('fd50', 8, 0x20c8),
        Register('fq52', 16, 0x20d0),
        Register('fd52', 8, 0x20d0),
        Register('fd54', 8, 0x20d8),
        Register('fq56', 16, 0x20e0),
        Register('fd56', 8, 0x20e0),
        Register('fd58', 8, 0x20e8),
        Register('fq60', 16, 0x20f0),
        Register('fd60', 8, 0x20f0),
        Register('fd62', 8, 0x20f8),
        Register('x_nf', 1, 0x3000),
        Register('x_zf', 1, 0x3001),
        Register('x_vf', 1, 0x3002),
        Register('x_cf', 1, 0x3003),
        Register('i_nf', 1, 0x3004),
        Register('i_zf', 1, 0x3005),
        Register('i_vf', 1, 0x3006),
        Register('i_cf', 1, 0x3007),
        Register('asiext', 8, 0x4000),
        Register('asi', 1, 0x4000),
        Register('fprsext', 8, 0x4008),
        Register('tpc1', 8, 0x5000),
        Register('fsr', 2, 0x5000),
        Register('fcc0', 1, 0x5002),
        Register('fcc1', 1, 0x5003),
        Register('fcc2', 1, 0x5004),
        Register('fcc3', 1, 0x5005),
        Register('tpc2', 8, 0x5008),
        Register('tpc3', 8, 0x5010),
        Register('didrestore', 1, 0x5010),
        Register('tpc4', 8, 0x5018),
        Register('tnpc1', 8, 0x5020),
        Register('decompile_mode', 1, 0x5020),
        Register('tnpc2', 8, 0x5028),
        Register('tnpc3', 8, 0x5030),
        Register('tnpc4', 8, 0x5038),
        Register('tstate1', 8, 0x5040),
        Register('tstate2', 8, 0x5048),
        Register('tstate3', 8, 0x5050),
        Register('tstate4', 8, 0x5058),
        Register('tt1', 8, 0x5060),
        Register('tt2', 8, 0x5068),
        Register('tt3', 8, 0x5070),
        Register('tt4', 8, 0x5078),
        Register('tck', 8, 0x5080),
        Register('tba', 8, 0x5088),
        Register('pstate', 8, 0x5090),
        Register('tl', 8, 0x5098),
        Register('pil', 8, 0x50a0),
        Register('cwp', 8, 0x50a8),
        Register('cansave', 8, 0x50b0),
        Register('canrestore', 8, 0x50b8),
        Register('cleanwin', 8, 0x50c0),
        Register('otherwin', 8, 0x50c8),
        Register('wstate', 8, 0x50d0),
        Register('fq', 8, 0x50d8),
        Register('ver', 8, 0x50e0),
        Register('gl', 8, 0x50e8),
        Register('hpstate1', 8, 0x6000),
        Register('hpstate2', 8, 0x6008),
        Register('hpstate3', 8, 0x6010),
        Register('hpstate4', 8, 0x6018),
        Register('htstate1', 8, 0x6020),
        Register('htstate2', 8, 0x6028),
        Register('htstate3', 8, 0x6030),
        Register('htstate4', 8, 0x6038),
        Register('resv2_1', 8, 0x6040),
        Register('resv2_2', 8, 0x6048),
        Register('resv2_3', 8, 0x6050),
        Register('resv2_4', 8, 0x6058),
        Register('hintp1', 8, 0x6060),
        Register('hintp2', 8, 0x6068),
        Register('hintp3', 8, 0x6070),
        Register('hintp4', 8, 0x6078),
        Register('resv4_1', 8, 0x6080),
        Register('resv4_2', 8, 0x6088),
        Register('resv4_3', 8, 0x6090),
        Register('resv4_4', 8, 0x6098),
        Register('htba1', 8, 0x60a0),
        Register('htba2', 8, 0x60a8),
        Register('htba3', 8, 0x60b0),
        Register('htba4', 8, 0x60b8),
        Register('hver1', 8, 0x60c0),
        Register('hver2', 8, 0x60c8),
        Register('hver3', 8, 0x60d0),
        Register('hver4', 8, 0x60d8),
        Register('resv30_1', 8, 0x60e0),
        Register('resv30_2', 8, 0x60e8),
        Register('resv30_3', 8, 0x60f0),
        Register('resv30_4', 8, 0x60f8),
        Register('hstick_cmpr1', 8, 0x6100),
        Register('hstick_cmpr2', 8, 0x6108),
        Register('hstick_cmpr3', 8, 0x6110),
        Register('hstick_cmpr4', 8, 0x6118),
        Register('w010', 8, 0x7000),
        Register('w011', 8, 0x7008),
        Register('w012', 8, 0x7010),
        Register('w013', 8, 0x7018),
        Register('w014', 8, 0x7020),
        Register('w015', 8, 0x7028),
        Register('w016', 8, 0x7030),
        Register('w017', 8, 0x7038),
        Register('w020', 8, 0x7040),
        Register('w021', 8, 0x7048),
        Register('w022', 8, 0x7050),
        Register('w023', 8, 0x7058),
        Register('w024', 8, 0x7060),
        Register('w025', 8, 0x7068),
        Register('w026', 8, 0x7070),
        Register('w027', 8, 0x7078),
        Register('w030', 8, 0x7080),
        Register('w031', 8, 0x7088),
        Register('w032', 8, 0x7090),
        Register('w033', 8, 0x7098),
        Register('w034', 8, 0x70a0),
        Register('w035', 8, 0x70a8),
        Register('w036', 8, 0x70b0),
        Register('w037', 8, 0x70b8),
        Register('w110', 8, 0x70c0),
        Register('w111', 8, 0x70c8),
        Register('w112', 8, 0x70d0),
        Register('w113', 8, 0x70d8),
        Register('w114', 8, 0x70e0),
        Register('w115', 8, 0x70e8),
        Register('w116', 8, 0x70f0),
        Register('w117', 8, 0x70f8),
        Register('w120', 8, 0x7100),
        Register('w121', 8, 0x7108),
        Register('w122', 8, 0x7110),
        Register('w123', 8, 0x7118),
        Register('w124', 8, 0x7120),
        Register('w125', 8, 0x7128),
        Register('w126', 8, 0x7130),
        Register('w127', 8, 0x7138),
        Register('w130', 8, 0x7140),
        Register('w131', 8, 0x7148),
        Register('w132', 8, 0x7150),
        Register('w133', 8, 0x7158),
        Register('w134', 8, 0x7160),
        Register('w135', 8, 0x7168),
        Register('w136', 8, 0x7170),
        Register('w137', 8, 0x7178),
        Register('w210', 8, 0x7180),
        Register('w211', 8, 0x7188),
        Register('w212', 8, 0x7190),
        Register('w213', 8, 0x7198),
        Register('w214', 8, 0x71a0),
        Register('w215', 8, 0x71a8),
        Register('w216', 8, 0x71b0),
        Register('w217', 8, 0x71b8),
        Register('w220', 8, 0x71c0),
        Register('w221', 8, 0x71c8),
        Register('w222', 8, 0x71d0),
        Register('w223', 8, 0x71d8),
        Register('w224', 8, 0x71e0),
        Register('w225', 8, 0x71e8),
        Register('w226', 8, 0x71f0),
        Register('w227', 8, 0x71f8),
        Register('w230', 8, 0x7200),
        Register('w231', 8, 0x7208),
        Register('w232', 8, 0x7210),
        Register('w233', 8, 0x7218),
        Register('w234', 8, 0x7220),
        Register('w235', 8, 0x7228),
        Register('w236', 8, 0x7230),
        Register('w237', 8, 0x7238),
        Register('w310', 8, 0x7240),
        Register('w311', 8, 0x7248),
        Register('w312', 8, 0x7250),
        Register('w313', 8, 0x7258),
        Register('w314', 8, 0x7260),
        Register('w315', 8, 0x7268),
        Register('w316', 8, 0x7270),
        Register('w317', 8, 0x7278),
        Register('w320', 8, 0x7280),
        Register('w321', 8, 0x7288),
        Register('w322', 8, 0x7290),
        Register('w323', 8, 0x7298),
        Register('w324', 8, 0x72a0),
        Register('w325', 8, 0x72a8),
        Register('w326', 8, 0x72b0),
        Register('w327', 8, 0x72b8),
        Register('w330', 8, 0x72c0),
        Register('w331', 8, 0x72c8),
        Register('w332', 8, 0x72d0),
        Register('w333', 8, 0x72d8),
        Register('w334', 8, 0x72e0),
        Register('w335', 8, 0x72e8),
        Register('w336', 8, 0x72f0),
        Register('w337', 8, 0x72f8),
        Register('w410', 8, 0x7300),
        Register('w411', 8, 0x7308),
        Register('w412', 8, 0x7310),
        Register('w413', 8, 0x7318),
        Register('w414', 8, 0x7320),
        Register('w415', 8, 0x7328),
        Register('w416', 8, 0x7330),
        Register('w417', 8, 0x7338),
        Register('w420', 8, 0x7340),
        Register('w421', 8, 0x7348),
        Register('w422', 8, 0x7350),
        Register('w423', 8, 0x7358),
        Register('w424', 8, 0x7360),
        Register('w425', 8, 0x7368),
        Register('w426', 8, 0x7370),
        Register('w427', 8, 0x7378),
        Register('w430', 8, 0x7380),
        Register('w431', 8, 0x7388),
        Register('w432', 8, 0x7390),
        Register('w433', 8, 0x7398),
        Register('w434', 8, 0x73a0),
        Register('w435', 8, 0x73a8),
        Register('w436', 8, 0x73b0),
        Register('w437', 8, 0x73b8),
        Register('w510', 8, 0x73c0),
        Register('w511', 8, 0x73c8),
        Register('w512', 8, 0x73d0),
        Register('w513', 8, 0x73d8),
        Register('w514', 8, 0x73e0),
        Register('w515', 8, 0x73e8),
        Register('w516', 8, 0x73f0),
        Register('w517', 8, 0x73f8),
        Register('w520', 8, 0x7400),
        Register('w521', 8, 0x7408),
        Register('w522', 8, 0x7410),
        Register('w523', 8, 0x7418),
        Register('w524', 8, 0x7420),
        Register('w525', 8, 0x7428),
        Register('w526', 8, 0x7430),
        Register('w527', 8, 0x7438),
        Register('w530', 8, 0x7440),
        Register('w531', 8, 0x7448),
        Register('w532', 8, 0x7450),
        Register('w533', 8, 0x7458),
        Register('w534', 8, 0x7460),
        Register('w535', 8, 0x7468),
        Register('w536', 8, 0x7470),
        Register('w537', 8, 0x7478),
        Register('w610', 8, 0x7480),
        Register('w611', 8, 0x7488),
        Register('w612', 8, 0x7490),
        Register('w613', 8, 0x7498),
        Register('w614', 8, 0x74a0),
        Register('w615', 8, 0x74a8),
        Register('w616', 8, 0x74b0),
        Register('w617', 8, 0x74b8),
        Register('w620', 8, 0x74c0),
        Register('w621', 8, 0x74c8),
        Register('w622', 8, 0x74d0),
        Register('w623', 8, 0x74d8),
        Register('w624', 8, 0x74e0),
        Register('w625', 8, 0x74e8),
        Register('w626', 8, 0x74f0),
        Register('w627', 8, 0x74f8),
        Register('w630', 8, 0x7500),
        Register('w631', 8, 0x7508),
        Register('w632', 8, 0x7510),
        Register('w633', 8, 0x7518),
        Register('w634', 8, 0x7520),
        Register('w635', 8, 0x7528),
        Register('w636', 8, 0x7530),
        Register('w637', 8, 0x7538),
        Register('w710', 8, 0x7540),
        Register('w711', 8, 0x7548),
        Register('w712', 8, 0x7550),
        Register('w713', 8, 0x7558),
        Register('w714', 8, 0x7560),
        Register('w715', 8, 0x7568),
        Register('w716', 8, 0x7570),
        Register('w717', 8, 0x7578),
        Register('w720', 8, 0x7580),
        Register('w721', 8, 0x7588),
        Register('w722', 8, 0x7590),
        Register('w723', 8, 0x7598),
        Register('w724', 8, 0x75a0),
        Register('w725', 8, 0x75a8),
        Register('w726', 8, 0x75b0),
        Register('w727', 8, 0x75b8),
        Register('w730', 8, 0x75c0),
        Register('w731', 8, 0x75c8),
        Register('w732', 8, 0x75d0),
        Register('w733', 8, 0x75d8),
        Register('w734', 8, 0x75e0),
        Register('w735', 8, 0x75e8),
        Register('w736', 8, 0x75f0),
        Register('w737', 8, 0x75f8)
    ]

register_arch(['sparc:be:64:default'], 64, Endness.BE, ArchPcode_sparc_BE_64_default)
